{$A-,B-,D+,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y-}
uses Memory,Drivers,Objects,Views,Menus,App,
MsgBox,Dialogs,Editors,stddlg,font,colors;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
type
  ttext = object(TApplication)
    ClipboardWindow: PEditWindow;
    constructor Init;
    destructor Done; virtual;
    procedure Idle;virtual;
    procedure doaboutbox(txt:string);
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure InitMenuBar; virtual;
    procedure InitStatusLine; virtual;
    procedure window;
    procedure NewWindow;
    procedure OpenWindow;
    procedure Changedir;
  end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
var
  ResFile: TResourceFile;
  TtextApp: ttext;

const
cmDesk            =201;

cmx               =204;
cmAbout           =205;

cmclip            =208;
cmintext          =209;

hcotevri          =201;

hcfind            =203;
hcreplace         =204;
hcsearchagain     =205;
hcexport          =206;

hcabout           =208;
hcfile            =209;
hcedit            =210;
hcsearch          =211;
hcoption          =212;
hcwindow          =213;
hcinfo            =214;
hcclip            =215;
hcdesk            =216;
hcintext          =217;

ecolor=CAppColor;
eblackwhite=CAppBlackWhite;
emono=CAppMonochrome;
editorpalettes:array[apColor..apMonochrome] of string[Length(ecolor)]=(ecolor, eblackwhite, emono);
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
constructor ttext.Init;
var
  R: TRect;
begin
  MaxHeapSize :={20480}8192;EditorDialog := StdEditorDialog;
  inherited Init;
  ClipboardWindow := New(PEditWindow, Init(R,'',wnNoNumber));
  if ValidView(ClipboardWindow) <> nil then
  begin
    ClipboardWindow^.Hide;InsertWindow(ClipboardWindow);
    Clipboard := ClipboardWindow^.Editor;Clipboard^.CanUndo := False;
  end;
  window;end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
destructor ttext.Done;
begin
inherited Done;end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure ttext.Idle;
begin
inherited Idle;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure ttext.DoAboutBox(txt:string);
begin
MessageBox(txt,nil,mfInformation or mfOKButton);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure ttext.Changedir;
var dirDialog: PchdirDialog;
begin
New(dirDialog,Init(0, 0));
ExecuteDialog(dirDialog,nil);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure ttext.HandleEvent(var Event: TEvent);
var
R: TRect;
begin
inherited HandleEvent(Event);if Event.What = evCommand then
case Event.Command of
cmNew:begin NewWindow;ClearEvent(Event);end;
cmOpen:begin OpenWindow;ClearEvent(Event);end;
cmchangedir:begin Changedir;ClearEvent(Event);end;
cmx:begin DoAboutBox(#3'Cedit'#13#13#3'Version 1.00.');ClearEvent(Event);end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure ttext.InitMenuBar;
var
  R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y+1;
  MenuBar := New(PMenuBar, Init(R,   NewMenu(
    NewSubMenu('File', hcfile, NewMenu(
      NewItem('~O~pen', 'F3', kbF3, cmopen,hcopen,
      NewItem('~N~ew', '', kbnokey, cmnew,hcnew,
      newline(
      NewItem('~S~ave','F2', kbF2, cmsave,hcsave,
      NewItem('Save  ~a~s', '', kbnokey, cmsaveas,hcsaveas,
      NewItem('Save a~l~l', '', kbnokey, cmsaveall,hcsaveall,
      newline(
      NewItem('~C~hange dir', '', kbnokey, cmchangedir,hcchangedir,
      NewItem('~E~xport to csp', '', kbnokey, cmexport,hcexport,
      NewItem('Export to Xchange ~c~as', '', kbnokey, cmcas,hcexport,
      NewItem('~D~OS-SHELL', '', kbnokey, cmdosshell,hcdosshell,
      NewItem('E~x~it', '', kbaltx,cmquit,hcexit,nil))))))))))))),
    NewSubMenu('Edit', hcedit, NewMenu(
      NewItem('~U~ndo','Alt+Backspace', kbaltback, cmundo,hcundo,
      NewItem('Cut ', 'Shift+Del', kbnokey, cmcut,hccut,
      NewItem('Copy', 'Ctrl+Ins', kbnokey, cmcopy,hccopy,
      NewItem('~P~aste', 'Shift+Ins', kbnokey, cmpaste,hcpaste,
      NewItem('Clear', 'Ctrl+Del', kbnokey, cmclear,hcclear,
      nil)))))),
    NewSubMenu('Window', hcwindow,newmenu(
    NewItem('~T~ile', '', kbNoKey, cmTile, hcTile,
    NewItem('C~a~scade', '', kbNoKey, cmCascade, hcCascade,
    NewLine(
    NewItem('~S~ize/Move','Ctrl+F5', kbCtrlF5, cmResize, hcResize,
    NewItem('~Z~oom', 'F5', kbF5, cmZoom, hcZoom,
    NewItem('~N~ext', 'F6', kbF6, cmNext, hcNext,
    NewItem('~P~revious', 'Shift+F6', kbShiftF6, cmPrev, hcPrev,
    NewItem('~C~lose', '', kbnokey, cmClose, hcClose,nil))))))))),
    NewSubMenu('Information', hcinfo, NewMenu(
    NewItem('~A~bout', '', kbnokey,cmx, hcabout,
      nil)),
    nil))))))
  );
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure ttext.InitStatusLine;
const tab:array[1..20]of word=(kbf1,kbf2,kbf3,kbf4,kbf5,kbf6,kbf7,kbf8,kbf9,kbf10,kbshiftf1,
kbshiftf2,kbshiftf3,kbshiftf4,kbshiftf5,kbshiftf6,kbshiftf7,kbshiftf8,kbshiftf9,kbshiftf10);
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function key(AText:String20;k:Word;ACommand:Word;ANext:PStatusItem):PStatusItem;
begin
if acommand>=3000 then acommand:=acommand-3000+247*256
else if acommand>=2000 then acommand:=acommand-2000+127*256;
key:=newstatuskey(atext,tab[k],acommand+1024,anext);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
var
  R: TRect;
  pom: PStatusDef;
begin
pom:=nil;
pom:=newstatusdef(hcgraph,hcgraph,
      Key('~1~^G Y=',1,238,Key('',11,3099,
      Key('~2~^G Y>',2,240,Key('',12,3106,
      Key('~3~^G Y<',3,241,Key('',13,3107,
      Key('~4~^G Y',4,242,Key('',14,3108,
      Key('~5~^G Y',5,243,Key('',15,3109,
      Key('~6~^G =',6,244,Key('',16,3100,
      Key('~7~^G XY',7,245,Key('',17,3101,
      Key('~8~ G ',8,239,
      Key('~9~^G X=',9,3098,Key('',19,3099,
  nil))))))))))))))))),pom);

  pom:=newstatusdef(hcplot,hcplot,
      Key('~1~ Plot',1,224,
      Key('~2~ PlOn',2,3168,
      Key('~3~ PlOff',3,3169,
      Key('~4~ PlChg',4,3170,
      Key('~5~ PxlOn',5,3171,
      Key('~6~ PxlOff',6,3172,
      Key('~7~ PxlChg',7,3173,
      Key('~8~ PxlTest',8,3175,
      Key('~9~ Cls',9, 209,
  nil))))))))),pom);

  pom:=newstatusdef(hccolor,hccolor,
      Key('~1~ Orange',1,2052,
      Key('~2~ Blue',2,2053,
      Key('~3~ Green',3,2054,
      Key('~4~ P/L Or',4,2049,
      Key('~5~ P/L Bl',5,2050,
      Key('~6~ P/L Gr',6,2051,
      Key('~7~ OrangeG',7,2055,
      Key('~8~ BlueG',8,2056,
      Key('~9~ GreenG',9,2057,
 nil))))))))),pom);

pom:=newstatusdef(hcsketch,hcsketch,
      Key('~1~ Line',1,225,
      Key('~2~ F-Line',2,3167,
      Key('~3~ PxlLine',3,3174,
      Key('~4~ Tang',4,3160,
      Key('~5~ Norm',5,3161,
      Key('~6~ Inv',6,3162,
      Key('~7~ Vert',7,3163,
      Key('~8~ Horis',8,3164,
      Key('~9~ Text',9,3165,
      Key('~10~ Circle',10,3166,
  nil)))))))))),pom);

pom:=newstatusdef(hcprgm,hcprgm,
      Key('~1~ Lbl', 1,226,
      Key('~2~ Goto',2,236,
      Key('~3~ '   ,3,19,
      Key('~4~ Isz', 4,233,
      Key('~5~ Dsz', 5,232,
      Key('~6~ Prog',6, 237,
      Key('~7~ Return',7, 3012,
      Key('~8~ Break',8,3013,
      Key('~9~ Stop',9,3014,
      Key('~10~ '  ,10,12,
  nil)))))))))),pom);


pom:=newstatusdef(hccond,hccond,
      Key('~1~ If'  , 1,3000,
      Key('~2~ Then', 2,3001,
      Key('~3~ Else', 3,3002,
      Key('~4~ IfEnd',4,3003,
      Key('~5~ Locate',5,3016,
      Key('~6~ Getkey',6,2143,
      Key('~7~ Send',  7,3017,
      Key('~8~ Receive',8,3018,
  nil)))))))),pom);

pom:=newstatusdef(hcloop,hcloop,
      Key('~1~ For', 1,3004,
      Key('~2~ To',  2,3005,
      Key('~3~ Step',3,3006,
      Key('~4~ Next',4,3007,
      Key('~5~ While',5,3008,
      Key('~6~ WhileEnd',6,3009,
      Key('~7~ Do',  7,3010,
      Key('~8~ LpWhile',8,3011,
  nil)))))))),pom);



pom:=newstatusdef(hcmem,hcmem,
      Key('~1~ Mcl' , 1, 210,
      Key('~2~ Scl',  2, 216,
      Key('~3~ ClrText',3,3024,
      Key('~4~ ClrGraph',4,3025,
      Key('~5~ ClrList', 5,3026,
      Key('~6~ Defm',   6, 229,
      Key('~7~ DT',7, 231,
      Key('~8~ Cl',8, 230,
  nil)))))))),pom);

pom:=newstatusdef(hcdrawg,hcdrawg,
      Key('~1~ DispF',    1,3046,
      Key('~2~ DispR',    2,3047,
      Key('~3~ DrGraph',  3,3032,
      Key('~4~ DrDyna',   4,3034,
      Key('~5~ DrStat',   5,3035,
      Key('~6~^DrFTG',    6,3036,Key(''  ,16,3037,
      Key('~7~^DrR',      7,3038,Key(''  ,17,3039,
      Key('~8~^DrRSum',   8,3040,Key(''  ,18,3041,
      Key('~9~ DrawWeb',  9,3042,
     nil)))))))))))),pom);


pom:=newstatusdef(hcstorcl,hcstorcl,
      Key('~1~ StoPict',  1,3147,
      Key('~2~ RclPict'  ,2,3148,
      Key('~3~ StoGMEM',  3,3149,
      Key('~4~ RclGMEM'  ,4,3150,
      Key('~5~ StoV-Win', 5,3151,
      Key('~6~ RclV-Win' ,6,3152,
       nil)))))),pom);

pom:=newstatusdef(hcfunc,hcfunc,
      Key('~1~^sin', 1, 129,Key(''  ,11,145,
      Key('~2~^cos', 2, 130,Key(''  ,12,146,
      Key('~3~^tan', 3, 131,Key(''  ,13,147,
      Key('~4~^sinh',4, 161,Key(''  ,14,177,
      Key('~5~^cosh',5, 162,Key(''  ,15,178,
      Key('~6~^tanh',6, 163,Key(''  ,16,179,
      Key('~7~^ln', 7,  133,Key(''  ,17,165,
      Key('~8~^log',8,  149,Key(''  ,18,181,
      Key('~9~ Pol', 9, 128,
      Key('~10~ Rec',10,160,
    nil)))))))))))))))))),pom);

pom:=newstatusdef(hcengl,hcengl,
      Key('~1~ ', 1, 1,
      Key('~2~ ', 2, 2,
      Key('~3~ ', 3, 3,
      Key('~4~ ', 4,  4,
      Key('~5~ ', 5,  5,
  nil))))),pom);

pom:=newstatusdef(hcengh,hcengh,
      Key('~1~ ', 1,  6,
      Key('~2~ ', 2, 7,
      Key('~3~ ', 3, 8,
      Key('~4~ ', 4, 9,
      Key('~5~ ', 5,10,
      Key('~6~ ', 6,11,
  nil)))))),pom);

pom:=newstatusdef(hccomp1,hccomp1,
      Key('~1~ +',  1, 137,
      Key('~2~ -',  2, 153,
      Key('~3~ ',  3, 169,
      Key('~4~ ',  4, 185,
      Key('~5~ ',  5, 187,
      Key('~6~ ',  6, 155,
      Key('~7~ ',  7, 135,
      Key('~8~ x', 8, 168,
      Key('~9~ ', 9, 184,
      Key('~10~ ',10, 15,
  nil)))))))))),pom);

pom:=newstatusdef(hccomp2,hccomp2,
      Key('~1~ ',  1, 134,
      Key('~2~ ',  2, 139,
      Key('~3~ ', 3, 150,
      Key('~4~ ',  4, 208,
      Key('~5~ ', 5, 205,
      Key('~6~ ', 6, 206,
      Key('~7~ Ans',7, 192,
      Key('~8~ ', 8, 16,
      Key('~9~ ', 9, 18,
      Key('~10~ ',10,17,
  nil)))))))))),pom);



pom:=newstatusdef(hcangle,hcangle,
      Key('~1~ Deg',1,218,
      Key('~2~ Rad',2,219,
      Key('~3~ Gra',3,220,
      Key('~4~ '  ,4,156,
      Key('~5~ '  ,5,172,
      Key('~6~ '  ,6,188,
      Key('~7~ ', 7,140,
  nil))))))),pom);

pom:=newstatusdef(hcrange,hcrange,
      Key('~1~^Xmin',  1,2000,Key(''  ,11,2016,
      Key('~2~^Xmax',  2,2001,Key(''  ,12,2017,
      Key('~3~^Xscl',  3,2002,Key(''  ,13,2018,
      Key('~4~^Ymin',  4,2004,Key(''  ,14,2020,
      Key('~5~^Ymax',  5,2005,Key(''  ,15,2021,
      Key('~6~^Yscl',  6,2006,Key(''  ,16,2022,
      Key('~7~^Tmin', 7,2008,Key(''  ,17,2024,
      Key('~8~^Tmax', 8,2009,Key(''  ,18,2025,
      Key('~9~^Tptch',9,2010,Key(''  ,19,2026,
  nil)))))))))))))))))),pom);

pom:=newstatusdef(hcfmem,hcfmem,
     Key('~1~ f', 1, 20,
     Key('~2~ f', 2, 21,
     Key('~3~ f', 3, 22,
     Key('~4~ f', 4, 23,
     Key('~5~ f', 5, 24,
     Key('~6~ f', 6, 25,
     Key('~7~ !', 7, 171,
     Key('~8~ ', 8, 136,
     Key('~9~ ', 9, 152,
     Key('~10~ Ran#', 10,193,
  nil)))))))))),pom);


pom:=newstatusdef(hcnum,hcnum,
      Key('~1~ Int' ,  1, 166,
      Key('~2~ Frac',  2, 182,
      Key('~3~ Abs',   3, 151,
      Key('~4~ Intg'  ,4,222,
      Key('~5~ Arg',   5,2034,
      Key('~6~ Rnd',   6, 211,
      Key('~7~ Conjg', 7,2035,
      Key('~8~ Re P',  8,2036,
      Key('~9~ Im P',  9,2037,
      Key('~10~ ',   10,2080,
  nil)))))))))),pom);

pom:=newstatusdef(hccalc,hccalc,
      Key('~1~ d/dx' , 1, 2038,
      Key('~2~ d/dx',2, 2039,
      Key('~3~ ',     3, 141,
      Key('~4~ Solve', 4, 2040,
      Key('~5~ ',     5, 2041,
      Key('~6~ FMin',  6, 2042,
      Key('~7~ FMax',  7, 2043,
  nil))))))),pom);


pom:=newstatusdef(hclist,hclist,
      Key('~1~ List' ,  1, 2081,
      Key('~2~ Seq',   2, 2044,
      Key('~3~ Min',   3, 2045,
      Key('~4~ Max',   4, 2032,
      Key('~5~ Mean',  5, 2046,
      Key('~6~ Median',6, 2047,
      Key('~7~ Sum',   7,2076,
      Key('~8~ Prod',  8,2077,
      Key('~9~ Cuml', 9,2079,
      Key('~10~ %(',   10,2078,
  nil)))))))))),pom);

pom:=newstatusdef(hcmat,hcmat,
      Key('~1~ Mat' ,   1, 2064,
      Key('~2~ Det' ,   2, 2033,
      Key('~3~ Trn' ,   3, 2065,
      Key('~4~ Dim' ,   4, 2070,
      Key('~5~ Identity',5, 2072,
      Key('~6~ MatList',6, 2075,
      Key('~7~ ListMat', 7, 2074,
      Key('~8~ Fill' ,  8, 2071,
      Key('~9~ Augment',9, 2073,
  nil))))))))),pom);

pom:=newstatusdef(hcarrop,hcarrop,
      Key('~1~ *Row' ,  1, 2066,
      Key('~2~ *Row+',  2, 2067,
      Key('~3~ Row+',   3, 2068,
      Key('~4~ Swap',   4, 2069,
      Key('~5~ Sort A', 5,3176,
      Key('~6~ Sort D' ,6,3177,
  nil)))))),pom);

pom:=newstatusdef(hcbase,hcbase,
      Key('~1~ ',1,   26,
      Key('~2~ ',2,   27,
      Key('~3~ ',3,   28,
      Key('~4~ ',4,   29,
      Key('~5~ ',5,   30,
      Key('~6~ ',6,   31,
      Key('~7~ h',7, 132,
      Key('~8~ d',8, 148,
      Key('~9~ b',9, 180,
      Key('~10~ o',10,164,
  nil)))))))))),pom);

pom:=newstatusdef(hclogic,hclogic,
      Key('~1~ Neg', 1,  183,
      Key('~2~ not', 2,  167,
      Key('~3~ and', 3,  186,
      Key('~4~ or',  4,  170,
      Key('~5~ xor', 5,  154,
      Key('~6~ xnor',6,  138,
      Key('~7~ Not', 7,2179,
      Key('~8~ And', 8,2176,
      Key('~9~ Or',  9,2177,
  nil))))))))),pom);

pom:=newstatusdef(hcrecvar,hcrecvar,
      Key('~1~^a',  1,2160,Key(''  ,11,2167,
      Key('~2~^aͧ',2,2161,Key(''  ,12,2168,
      Key('~3~^aͨ',3,2162,Key(''  ,13,2169,
      Key('~4~ ',   4,2163,
      Key('~5~^a',  5,2164,Key(''  ,15,2170,
      Key('~6~^a',  6,2165,Key(''  ,16,2171,
      Key('~7~^a',  7,2166,Key(''  ,17,2172,
      Key('~8~^aStart', 8,2173,Key(''  ,18,2174,
  nil))))))))))))))),pom);

pom:=newstatusdef(hclists,hclists,
      Key('~1~^List1',  1,2106,Key(''  ,11,3178,
      Key('~2~^List2',  2,2107,Key(''  ,12,3179,
      Key('~3~^List3',  3,2108,Key(''  ,13,3180,
      Key('~4~^List4',  4,2109,Key(''  ,14,3181,
      Key('~5~^List5',  5,2110,Key(''  ,15,3182,
      Key('~6~^List6',  6,2111,Key(''  ,16,3183,
      Key('~7~ VarRange',7,3136,
      Key('~8~ List X',8,2152,
      Key('~9~ List Y',9,2153,
  nil))))))))))))))),pom);

pom:=newstatusdef(hclistfile,hclistfile,
      Key('~1~ File1', 1,3184,
      Key('~2~ File2', 2,3185,
      Key('~3~ File3', 3,3186,
      Key('~4~ File4', 4,3187,
      Key('~5~ File5', 5,3188,
      Key('~6~ File6', 6,3189,
  nil)))))),pom);

pom:=newstatusdef(hcsetup,hcsetup,
      Key('~1~^Func', 1,3192,Key('',11,3208,
      Key('~2~^Simul',2,3193,Key('',12,3209,
      Key('~3~^Axes', 3,3194,Key('',13,3210,
      Key('~4~^Coord',4,3195,Key('',14,3211,
      Key('~5~^Label',5,3196,Key('',15,3212,
      Key('~6~^Deriv',6,3197,Key('',16,3213,
      Key('~7~^Locus',7,3198,Key('',17,3214,
      Key('~8~^disp',8,3199,Key('',18,3215,
  nil)))))))))))))))),pom);

pom:=newstatusdef(hcsdx,hcsdx,
      Key('~1~ n', 1,175 ,
      Key('~2~ ', 2,194 ,
      Key('~3~ x',3, 159,
      Key('~4~ x',4,143,
      Key('~5~ xn',5,196,
      Key('~6~ xn',6,197,
      Key('~7~ minX',7,174,
      Key('~8~ maxX',8,190,
      Key('~9~ ', 9,203,
  nil))))))))),pom);

pom:=newstatusdef(hcsdy,hcsdy,
      Key('~1~ xy', 1,223 ,
      Key('~2~ ', 2,195 ,
      Key('~3~ y',3, 207,
      Key('~4~ y',4,191,
      Key('~5~ yn',5,198,
      Key('~6~ yn',6,199,
      Key('~7~ minY',7,173,
      Key('~8~ maxY',8,189,
      Key('~9~ ', 9,204,
  nil))))))))),pom);
pom:=newstatusdef(hcreg,hcreg,
      Key('~1~ ', 1, 200,
      Key('~2~ ', 2, 201,
      Key('~3~ c', 3, 2029,
      Key('~4~ d', 4, 2030,
      Key('~5~ e', 5, 2031,
      Key('~6~ r', 6, 202,
      Key('~7~ Q',7, 2118,
      Key('~8~ Med',8,158,
      Key('~9~ Q',9, 2119,
      Key('~10~ Mod',10,142,
  nil)))))))))),pom);

pom:=newstatusdef(hcsd,hcsd,
      Key('~1~ x', 1, 2120,
      Key('~2~ y', 2, 2121,
      Key('~3~ x', 3, 2122,
      Key('~4~ y', 4, 2123,
      Key('~5~ x', 5, 2124,
      Key('~6~ y', 6, 2125,
      Key('~7~ P',7,  251,
      Key('~8~ Q',8,252,
      Key('~9~ R',9, 253 ,
      Key('~10~ t',10,254,
  nil)))))))))),pom);

pom:=newstatusdef(hcdisp,hcdisp,
      Key('~1~ Dec',1,212,
      Key('~2~ Hex',2,213,
      Key('~3~ Bin',3,214,
      Key('~4~ Oct',4,215,
      Key('~5~ Fix',5,227,
      Key('~6~ Sci',6,228,
      Key('~7~ Norm',7,217,
      Key('~8~ Eng', 8,221,
  nil)))))))),pom);

pom:=newstatusdef(hcdraw,hcdraw,
      Key('~1~ Factor',1,234,
      Key('~2~ Range',2,235,
      Key('~3~ Cls',3,209,
      Key('~4~ Xfct',4,2011,
      Key('~5~ Yfct',5,2012,
  nil))))),pom);

pom:=newstatusdef(hcsel,hcsel,
      Key('~1~^G Sel',1,3200,Key('',11,3216,
      Key('~2~^T Sel',2,3201,Key('',12,3217,
      Key('~3~^D Sel',3,3202,Key('',13,3218,
      Key('~4~^R Sel',4,3203,Key('',14,3219,
      Key('~5~^Draw', 5,3204,Key('',15,3220,
  nil)))))))))),pom);

pom:=newstatusdef(hcvar1,hcvar1,
      Key('~1~ D Start',1,2013,
      Key('~2~ D End'  ,2,2014,
      Key('~3~ D Pitch',3,2015,
      Key('~4~ SimCoef',4,2096,
      Key('~5~ PlyCoef',5,2097,
      Key('~6~ SimResult',6,2098,
      Key('~7~ PlyResult',7,2099,
  nil))))))),pom);

pom:=newstatusdef(hcvar2,hcvar2,
      Key('~1~ F Result',1,2144,
      Key('~2~ F Start' ,2,2145,
      Key('~3~ F End',3,2146,
      Key('~4~ F Pitch',4,2147,
      Key('~5~ R Result',5,2148,
      Key('~6~ R Start',6,2149,
      Key('~7~ R End',7,2150,
      Key('~8~ R Pitch',8,2151,
  nil)))))))),pom);

pom:=newstatusdef(hcsimb,hcsimb,
      Key('~1~ Sim X',1,2112,
      Key('~2~ Sim Y',2,2113,
      Key('~3~ Sim Z',3,2114,
      Key('~4~ Sim T',4,2115,
      Key('~5~ Sim U',5,2116,
      Key('~6~ Sim V',6,2117,
      Key('~7~ Ply X',7,2128,
      Key('~8~ Ply X',8,2129,
      Key('~9~ Ply X',9,2130,
  nil))))))))),pom);

pom:=newstatusdef(hcsdmark,hcsdmark,
      Key('~1~ Square'    ,1,3077,
      Key('~2~ Cross'     ,2,3078,
      Key('~3~ Dot'       ,3,3079,
      Key('~4~ S-WindAuto',4,3096,
      Key('~5~ S-WindMan' ,5,3097,
  nil))))),pom);

pom:=newstatusdef(hcgrvar,hcgrvar,
      Key('~1~ Y ',1,2240,
      Key('~2~ r '  ,2,2241,
      Key('~3~ Xt',3,2242,
      Key('~4~ Yt',4,2243,
      Key('~5~ X ',5,2244,
      Key('~6~  ',6,246,
      Key('~7~ G-Connect',7,3112,
      Key('~8~ G-Plot',8,3113,
      Key('~9~ ',9,14,
  nil))))))))),pom);

pom:=newstatusdef(hcregtype,hcregtype,
      Key('~1~^Linear',1,3087,  Key('',11,3066,
      Key('~2~^Med-Med' ,2,3088,Key('',12,3067,
      Key('~3~^Quad',3,3089,    Key('',13,3068,
      Key('~4~^Cubic',4,3090,   Key('',14,3069,
      Key('~5~^Quad',5,3091,    Key('',15,3070,
      Key('~6~^Log',6,3092,     Key('',16,3071,
      Key('~7~^Exp',7,3093,     Key('',17,3072,
      Key('~8~^Power',8,3094,   Key('',18,3073,
  nil)))))))))))))))),pom);

pom:=newstatusdef(hcsdset,hcsdset,
      Key('~1~ 1-Variable',1,3064,
      Key('~2~ 2-Variable',2,3065,
      Key('~3~ S-Gph1'    ,3,3074,
      Key('~4~ S-Gph2'    ,4,3075,
      Key('~5~ S-Gph3'    ,5,3076,
  nil))))),pom);

pom:=newstatusdef(hcsdgrtype,hcsdgrtype,
      Key('~1~ Scatter',1,3080,
      Key('~2~ xyLine' ,2,3081,
      Key('~3~ Hist',3,3082,
      Key('~4~ MedBox',4,3083,
      Key('~5~ MeanBox',5,3084,
      Key('~6~ N-Dist',6,3085,
      Key('~7~ Broken',7,3086,
  nil))))))),pom);

pom:=newstatusdef(hcgrset,hcgrset,
      Key('~1~ DualG',1,3114,
      Key('~2~ DGtoT',2  ,3115,
      Key('~3~ DT+G',3   ,3116,
      Key('~4~ DOff',4   ,3117,
      Key('~5~ BG-None',5,3120,
      Key('~6~ BG-Pict',6,3121,
      Key('~7~ GOff',7,3122,
      Key('~8~ GDot',8,3123,
      Key('~9~ GLine',9,3124,
      Key('~10~ GOn',10,3125,
  nil)))))))))),pom);

pom:=newstatusdef(hcdynaset,hcdynaset,
      Key('~1~ NrmSpeed',1,3129,
      Key('~2~ Fast',2  ,3130,
      Key('~3~ Slow',3   ,3131,
      Key('~4~ Stop&Go',4   ,3132,
      Key('~5~ DynaCon',5,3133,
      Key('~6~ DynaStop',6,3134,
      Key('~7~ D Var',7,3128,
  nil))))))),pom);

pom:=newstatusdef(hcset,hcset,
      Key('~1~ Simul',1,3138,
      Key('~2~ Poly',2  ,3139,
      Key('~3~ aType',3   ,3144,
      Key('~4~ ąType',4   ,3145,
      Key('~5~ ąType',5,3146,
      Key('~6~ AutoSimp',6,3048,
      Key('~7~ ManSimp',7,3049,
      Key('~8~ MixedFrac',8,3056,
      Key('~9~ ImproperFrac',9,3057,
  nil))))))))),pom);

{+++++++++++++++++++++++++++++}
pom:=newstatusdef(hctoparray,hctoparray,
      NewStatusKey('~1~ MAT', kbf1, hcmat,
      NewStatusKey('~2~ LIST', kbF2,hclist,
      NewStatusKey('~3~ ARRAY OP.', kbF3, hcarrop,
      NewStatusKey('~4~ LISTS', kbF4, hclists,
      NewStatusKey('~5~ FILE', kbf5, hclistfile,
  nil))))),pom);

pom:=newstatusdef(hctopprog,hctopprog,
      NewStatusKey('~1~ PRGM', kbf1, hcprgm,
      NewStatusKey('~2~ COND,IO', kbF2,hccond,
      NewStatusKey('~3~ LOOP', kbF3, hcloop,
      NewStatusKey('~4~ LOGIC', kbF4, hclogic,
      NewStatusKey('~5~ STO/RCL', kbf5, hcstorcl,
      NewStatusKey('~6~ MEM', kbF6, hcmem,
      NewStatusKey('~7~ COLOR', kbF7, hccolor,
      NewStatusKey('~8~ DISP', kbf8, hcdisp,
  nil)))))))),pom);

pom:=newstatusdef(hctopdraw,hctopdraw,
      NewStatusKey('~1~ GRAPH', kbf1, hcgraph,
      NewStatusKey('~2~ DRAW', kbF2,hcsketch,
      NewStatusKey('~3~ PLOT', kbF3, hcplot,
      NewStatusKey('~4~ RANGE', kbF4, hcrange,
      NewStatusKey('~5~ DRAW-SET', kbf5, hcdraw,
      NewStatusKey('~6~ DRAW-G', kbF6, hcdrawg,
      NewStatusKey('~7~ GRAPH-VAR', kbf7, hcgrvar,
  nil))))))),pom);

pom:=newstatusdef(hctopcalc,hctopcalc,
      NewStatusKey('~1~ FUNC', kbf1, hcfunc,
      NewStatusKey('~2~ N-BASE', kbF2,hcbase,
      NewStatusKey('~3~ ENG Lo', kbF3, hcengl,
      NewStatusKey('~4~ ENG Hi', kbF4, hcengh,
      NewStatusKey('~5~ F-MEM', kbf5, hcfmem,
      NewStatusKey('~6~ NUM', kbF6, hcnum,
      NewStatusKey('~7~ COMP1', kbf7, hccomp1,
      NewStatusKey('~8~ COMP2', kbf8, hccomp2,
      NewStatusKey('~9~ CALC', kbf9, hccalc,
      NewStatusKey('~10~ ANGLE', kbf10, hcangle,
  nil)))))))))),pom);

pom:=newstatusdef(hctopsd,hctopsd,
      NewStatusKey('~1~ SDx', kbf1, hcsdx,
      NewStatusKey('~2~ SDy', kbF2,hcsdy,
      NewStatusKey('~3~ REG', kbF3, hcreg,
      NewStatusKey('~4~ SD', kbF4, hcsd,
      NewStatusKey('~5~ SD MARK', kbf5, hcsdmark,
      NewStatusKey('~6~ REG TYPE', kbF6, hcregtype,
      NewStatusKey('~7~ SD SET', kbf7, hcsdset,
      NewStatusKey('~8~ SD G TYPE', kbf8, hcsdgrtype,
  nil)))))))),pom);

pom:=newstatusdef(hctopsetup,hctopsetup,
      NewStatusKey('~1~ SETUP', kbf1, hcsetup,
      NewStatusKey('~2~ SELECT', kbF2,hcsel,
      NewStatusKey('~3~ RECVAR', kbF3, hcrecvar,
      NewStatusKey('~4~ SET', kbF4, hcset,
      NewStatusKey('~5~ VAR 1', kbf5, hcvar1,
      NewStatusKey('~6~ VAR 2', kbF6, hcvar2,
      NewStatusKey('~7~ SIMB', kbf7, hcsimb,
      NewStatusKey('~8~ GR SET', kbf8, hcgrset,
      NewStatusKey('~9~ DYNA SET', kbf9, hcdynaset,
  nil))))))))),pom);

  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  New(StatusLine, Init(R,
  NewStatusDef(0, 100,
      NewStatusKey('~F1~ Tokens            ', kbf1,cmcommand,
      NewStatusKey('~F2~ Save', kbnokey,cmsave,
      NewStatusKey('~F3~ Open', kbF3, cmOpen,
      NewStatusKey('~F4~ New', kbF4, cmnew,
      NewStatusKey('~F10~ Menu', kbF10, cmmenu,
      NewStatusKey('', kbshiftf6, cmprev,nil)))))),

      newstatusdef(hccommand,hccommand,
      NewStatusKey('~1~ ARRAY', kbf1, hctoparray,
      NewStatusKey('~2~ PROGRAM', kbF2,hctopprog,
      NewStatusKey('~3~ DRAW', kbF3, hctopdraw,
      NewStatusKey('~4~ COMPUTE', kbF4, hctopcalc,
      NewStatusKey('~5~ STATISTICS', kbf5, hctopsd,
      NewStatusKey('~6~ SETUP', kbF6, hctopsetup,
  nil)))))),pom))));



      end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{procedure ttext.help;
begin
MessageBox('',nil,mfInformation or mfOKButton);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure ttext.NewWindow;
var
  R: TRect;
  TheWindow: PEditWindow;
begin
  R.Assign(0, 0, 80, 23);
  TheWindow := New(PEditWindow, Init(R,'', 0));
  InsertWindow(TheWindow);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure ttext.Window;
var i:byte;
R: TRect;TheWindow:PEditWindow;
begin
for i:=1 to paramcount do
begin
R.Assign(i-1,i-1,80,23);
TheWindow:=New(PEditWindow,Init(R,paramstr(i),0));
InsertWindow(TheWindow);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure ttext.OpenWindow;
var
R:TRect;FileDialog: PFileDialog;TheFile: FNameStr;
const FDOptions: Word = fdOKButton or fdOpenButton;
begin
TheFile := '*.CAS';
New(FileDialog,Init(TheFile,'Open a file','~N~ame',FDOptions, 1));
if ExecuteDialog(FileDialog, @TheFile) <> cmCancel then
begin
R.Assign(0,0,80,23);InsertWindow(New(PEditWindow,Init(R,TheFile,0)));
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin
  TtextApp.Init;
  TtextApp.Run;
  TtextApp.Done;
end.
